/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.control;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.BandejaPapel0;
import com.ejie.ad74a.model.DocumentoPapel0;
import com.ejie.ad74a.model.MaestroTiposDoc;
import com.ejie.ad74a.service.DocumentoPapel0Service;
import com.ejie.ad74a.service.MaestroTiposDocService;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.constantes.TiposDocumentoRoleEnum;
import com.ejie.ad74a.ws.client.dokusi.service.DokusiService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

/**
 * DocumentoPapel0Controller generated by UDA, 19-abr-2023 10:08:16.
 * 
 * @author UDA
 */
@Controller
@RequestMapping(value = "/documentopapel0")
public class DocumentoPapel0Controller {
	private static final Logger logger = LoggerFactory.getLogger(DocumentoPapel0Controller.class);

	@Autowired
	private DocumentoPapel0Service documentoPapel0Service;

	@Autowired
	private MaestroTiposDocService maestroTiposDocService;

	@Autowired
	private DokusiService dokusiService;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 */

	/**
	 * Operación CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idDocPapel013 Long
	 *
	 * @return DocumentoPapel0 Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idDocPapel013}", method = RequestMethod.GET)
	public @ResponseBody DocumentoPapel0 get(@PathVariable Long idDocPapel013) {
		DocumentoPapel0 documentoPapel0 = new DocumentoPapel0();
		documentoPapel0.setIdDocPapel013(idDocPapel013);
		documentoPapel0 = this.documentoPapel0Service.find(documentoPapel0);
		DocumentoPapel0Controller.logger.info("[GET - findBy_PK] : Obtener DocumentoPapel0 por PK");
		return documentoPapel0;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parámetro.
	 *
	 * @param filterDocumentoPapel0 Objeto DocumentoPapel0 que contiene los
	 *                              parámetros de filtrado utilizados en la
	 *                              búsqueda.
	 *
	 * @return List<DocumentoPapel0> Lista de objetos correspondientes a la búsqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<DocumentoPapel0> getAll(@ModelAttribute DocumentoPapel0 filterDocumentoPapel0) {
		DocumentoPapel0Controller.logger.info("[GET - find_ALL] : Obtener DocumentoPapel0 por filtro");
		return this.documentoPapel0Service.findAll(filterDocumentoPapel0, null);
	}

	/**
	 * Operación CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param documentoPapel0 Bean DocumentoPapel0 que contiene la informacion a
	 *                        modificar.
	 *
	 * @return DocumentoPapel0 Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody DocumentoPapel0 edit(@RequestBody DocumentoPapel0 documentoPapel0) {
		DocumentoPapel0 documentoPapel0Aux = this.documentoPapel0Service.update(documentoPapel0);
		DocumentoPapel0Controller.logger.info("[PUT] : DocumentoPapel0 actualizado correctamente");
		return documentoPapel0Aux;
	}

	/**
	 * Operación CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param documentoPapel0 Bean DocumentoPapel0 que contiene la informacion con
	 *                        la que se va a crear el nuevo registro.
	 *
	 * @return DocumentoPapel0 Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody DocumentoPapel0 add(@RequestBody DocumentoPapel0 documentoPapel0) {
		DocumentoPapel0 documentoPapel0Aux = this.documentoPapel0Service.add(documentoPapel0);
		DocumentoPapel0Controller.logger.info("[POST] : DocumentoPapel0 insertado correctamente");
		return documentoPapel0Aux;
	}

	/**
	 * Operación CRUD Delete. Borrado del registro correspondiente a partir del
	 * identificador especificado.
	 *
	 * @param idDocPapel013 Long Identificador del objeto que se desea eliminar.
	 *
	 * @return DocumentoPapel0 Bean eliminado.
	 */
	@RequestMapping(value = "/{idDocPapel013}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody DocumentoPapel0 delete(@PathVariable Long idDocPapel013) {
		DocumentoPapel0 documentoPapel0 = new DocumentoPapel0();
		documentoPapel0.setIdDocPapel013(idDocPapel013);
		this.documentoPapel0Service.remove(documentoPapel0);
		DocumentoPapel0Controller.logger.info("[DELETE] : DocumentoPapel0 borrado correctamente");
		return documentoPapel0;
	}

	/*
	 * MÉTODOS COMPONENTE RUP_TABLE
	 */

	/**
	 * Método de presentación del RUP_TABLE.
	 * 
	 * @param model Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getMaint(Model model) {
		DocumentoPapel0Controller.logger.info("[GET - View] : documentopapel0");
		model.addAttribute("documentopapel0", new DocumentoPapel0());
		return "documentopapel0";
	}

	/**
	 * Obtener el formulario de edición.
	 * 
	 * @param actionType   String
	 * @param fixedMessage String
	 * @param model        Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/editForm", method = RequestMethod.POST)
	public String getEditForm(@RequestParam(required = true) String actionType,
			@RequestParam(required = false) String fixedMessage, Model model) {
		DocumentoPapel0Controller.logger.info("[POST - editForm] : documentopapel0");

		model.addAttribute("documentopapel0", new DocumentoPapel0());
		model.addAttribute("actionType", actionType);

		if (fixedMessage != null) {
			model.addAttribute("fixedMessage", fixedMessage);
		}

		return "documentopapel0EditForm";
	}

	/**
	 * Obtener el formulario necesario para permitir el uso de la edición en línea.
	 * 
	 * @param actionType String
	 * @param tableID    String
	 * @param mapping    String
	 * @param model      Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/inlineEdit", method = RequestMethod.POST)
	public String getInlineEditForm(@RequestParam(required = true) String actionType,
			@RequestParam(required = true) String tableID, @RequestParam(required = false) String mapping,
			Model model) {
		DocumentoPapel0Controller.logger.info("[POST - inlineEditForm] : documentopapel0");

		model.addAttribute("entity", new DocumentoPapel0());
		model.addAttribute("actionType", actionType);
		model.addAttribute("tableID", tableID);

		// Controlar que el mapping siempre se añada al modelo de la manera esperada
		if (mapping == null || mapping.isEmpty()) {
			mapping = "/documentopapel0";
		} else if (mapping.endsWith("/")) {
			mapping = mapping.substring(0, mapping.length() - 1);
		}
		model.addAttribute("mapping", mapping);

		return "documentopapel0InlineEditAuxForm";
	}

	/**
	 * Operación de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterDocumentoPapel0 Bean DocumentoPapel0 que contiene los parámetros
	 *                              de filtrado a emplear.
	 * @param tableRequestDto       Dto que contiene los parámetros de configuración
	 *                              propios del RUP_TABLE a aplicar en el filtrado.
	 *
	 * @return TableResponseDto<DocumentoPapel0> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<DocumentoPapel0> filter(
			@RequestJsonBody(param = "filter") DocumentoPapel0 filterDocumentoPapel0,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocumentoPapel0Controller.logger.info("[POST - filter] : Obtener DocumentoPapel0s");
		return this.documentoPapel0Service.filter(filterDocumentoPapel0, tableRequestDto, false);
	}

	/**
	 * Operación de búsqueda del componente RUP_TABLE.
	 * 
	 * @param filterDocumentoPapel0 Bean DocumentoPapel0 que contiene los parámetros
	 *                              de filtrado a emplear.
	 * @param searchDocumentoPapel0 Bean DocumentoPapel0 que contiene los parámetros
	 *                              de búsqueda a emplear.
	 * @param tableRequestDto       Dto que contiene los parámetros de configuración
	 *                              propios del RUP_TABLE a aplicar en la búsqueda.
	 *
	 * @return TableRowDto<DocumentoPapel0> Dto que contiene el resultado de la
	 *         búsqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<DocumentoPapel0>> search(
			@RequestJsonBody(param = "filter") DocumentoPapel0 filterDocumentoPapel0,
			@RequestJsonBody(param = "search") DocumentoPapel0 searchDocumentoPapel0,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocumentoPapel0Controller.logger.info("[POST - search] : Buscar DocumentoPapel0s");
		return this.documentoPapel0Service.search(filterDocumentoPapel0, searchDocumentoPapel0, tableRequestDto, false);
	}

	/**
	 * Borrado múltiple de registros
	 * 
	 * @param filterDocumentoPapel0 Bean DocumentoPapel0 que contiene los parámetros
	 *                              de filtrado a emplear.
	 * @param tableRequestDto       Dto que contiene los parámetros de configuración
	 *                              propios del RUP_TABLE a aplicar en la búsqueda.
	 *
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> deleteMultiple(TableRequestDto tableRequestDto) {
		DocumentoPapel0Controller.logger.info("[POST - deleteMultiple] : Eliminar multiples DocumentoPapel0s");
		this.documentoPapel0Service.removeMultiple(tableRequestDto);
		DocumentoPapel0Controller.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/**
	 * EXPORTERS
	 */

	/**
	 * Devuelve los datos exportados de la tabla y los copia al portapapeles.
	 *
	 * @param filterDocumentoPapel0 DocumentoPapel0
	 * @param columns               String[]
	 * @param columnsName           String[]
	 * @param reportsParams         ArrayList<?>
	 * @param tableRequestDto       TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	public @ResponseBody List<DocumentoPapel0> getClipboardReport(
			@RequestJsonBody(param = "filter") DocumentoPapel0 filterDocumentoPapel0,
			@RequestParam(required = false) String[] columns, @RequestParam(required = false) String[] columnsName,
			@RequestParam(required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		DocumentoPapel0Controller.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.documentoPapel0Service.getDataForReports(filterDocumentoPapel0, tableRequestDto);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocumentoPapel0
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) DocumentoPapel0 filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		DocumentoPapel0Controller.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");
		this.documentoPapel0Service.generateReport(filter, columns, columnsName, fileName, sheetTitle, reportsParams,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocumentoPapel0
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generatePDFReport(
			@RequestJsonBody(param = "filter", required = false) DocumentoPapel0 filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocumentoPapel0Controller.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");
		this.documentoPapel0Service.generateReport(filter, columns, columnsName, fileName, sheetTitle, reportsParams,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocumentoPapel0
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateODSReport(
			@RequestJsonBody(param = "filter", required = false) DocumentoPapel0 filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocumentoPapel0Controller.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");
		this.documentoPapel0Service.generateReport(filter, columns, columnsName, fileName, sheetTitle, reportsParams,
				tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          DocumentoPapel0
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateCSVReport(
			@RequestJsonBody(param = "filter", required = false) DocumentoPapel0 filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		DocumentoPapel0Controller.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");
		this.documentoPapel0Service.generateReport(filter, columns, columnsName, fileName, sheetTitle, reportsParams,
				tableRequestDto, request, response);
	}

	/**
	 * Obtiene todos los documentos de una entrada del libro de registro
	 * 
	 * @param documentoPapel0
	 * @return List<DocumentoPapel0>
	 */
	@RequestMapping(value = "/getAllByEntrada", method = RequestMethod.POST)
	public @ResponseBody List<DocumentoPapel0> getAllByEntrada(@RequestBody BandejaPapel0 bandejaPapel0) {
		DocumentoPapel0Controller.logger.info("[POST - getAllByEntrada] : DocumentoPapel0");

		DocumentoPapel0 documentoPapel0 = new DocumentoPapel0();
		documentoPapel0.setBandejaPapel0(bandejaPapel0);
		return this.documentoPapel0Service.getAllByEntrada(documentoPapel0);

	}

	/**
	 * Function to change the role of a document
	 * 
	 * @param filter
	 * @return
	 */
	@PostMapping(value = "/changeRoleDocument")
	public @ResponseBody String changeRoleDocument(@RequestBody HashMap<String, Object> filter) {

		DocumentoPapel0Controller.logger.info("changeRoleDocument");

		MaestroTiposDoc tipoDoc = new MaestroTiposDoc();
		DocumentoPapel0 documentoEntrada = new DocumentoPapel0();

		String oidDokusi = (String) filter.get("oidDocumento13");
		Long idTipoDocTipificar = -1L;

		// recuperamos el tipo de documento si lo tiene
		if (null != filter.get("idTipoDoc13")) {
			idTipoDocTipificar = Long.valueOf((Integer) filter.get("idTipoDoc13"));
		}
		// Long idTipoDocTipificar = Long.valueOf((Integer) filter.get("idTipoDoc13"));

		HashMap<String, String> bandejaStr = (HashMap<String, String>) filter.get("bandejaPapel0");
		String procedureID = bandejaStr.get("procedureid12");

		tipoDoc.setRoleid36((String) filter.get("roleid13"));
		List<MaestroTiposDoc> listaTiposDoc = this.maestroTiposDocService.findAll(tipoDoc, null);

		if (listaTiposDoc.get(0).getIdTipoDoc36().compareTo(idTipoDocTipificar) == 0) {
			ManagerErrors.manageError("error.tipificar.mismoRoleId");
		}

		com.ejie.ad74a.ws.client.dokusi.model.papel0.Documento docDokusi = getDocumentoDokusi(oidDokusi,
				listaTiposDoc.get(0), procedureID);

		// si ya tiene un idTipoDocTipificar, significa que ya se ha hecho el tramitate,
		// y hay que hacer retramitate
		boolean resultado = false;

		documentoEntrada.setOidDocumento13(oidDokusi);
		documentoEntrada.setIdTipoDoc13(listaTiposDoc.get(0).getIdTipoDoc36());
		documentoEntrada.setUsuModif13(UtilSeguridad.getUsuarioConectado().getNif());
		documentoEntrada.setNombreDoc13(this.maestroTiposDocService
				.find(new MaestroTiposDoc(listaTiposDoc.get(0).getIdTipoDoc36())).getDescEs36());
		resultado = this.documentoPapel0Service.updateRoleDocument(documentoEntrada, idTipoDocTipificar, docDokusi);

		if (!resultado) {
			ManagerErrors.manageError("error.tipificar.generico");
		}

		return "true";

		// return String.valueOf(resultado);
	}

	private com.ejie.ad74a.ws.client.dokusi.model.papel0.Documento getDocumentoDokusi(String oidDokusi,
			MaestroTiposDoc tipoDoc, String procedureID) {
		com.ejie.ad74a.ws.client.dokusi.model.papel0.Documento docDokusi = new com.ejie.ad74a.ws.client.dokusi.model.papel0.Documento();
		com.ejie.ad74a.ws.client.dokusi.model.papel0.User user = new com.ejie.ad74a.ws.client.dokusi.model.papel0.User();

		String senderID = UtilSeguridad.getUsuarioConectado().getNif();
		String senderName = UtilSeguridad.getUsuarioConectado().getFullName();

		user.setDni(senderID);
		user.setNombre(senderName);
		docDokusi.setOidDokusi(oidDokusi);
		/*
		 * IMPORTANTE: El roleId de platea no coincide con el de Dokusi. Pueden darse
		 * dos casos - El segundo tipo documental sea 0
		 * ejgv_d_informe.0.X87_Ficha_Sanitaria -> Se coge ejgv_d_informe
		 * 
		 * - El segundo tipo documental no sea 0
		 * ejgv_d_certificado.ejgv_d_certificado_interope.
		 * 0011_INTEROP_OBLIGATORIOUSAR_PADR -> se coge ejgv_d_certificado_interope
		 *
		 */
		String roleIdDokusi = "";
		String[] tiposdoc = tipoDoc.getRoleid36().split("\\.");
		if (Arrays.asList(tiposdoc).contains("0")) {
			roleIdDokusi = tiposdoc[Arrays.asList(tiposdoc).indexOf("0") - 1];
		} else {
			roleIdDokusi = tiposdoc[tiposdoc.length - 2];
		}

		docDokusi.setNewRoleId(roleIdDokusi);
		docDokusi.setUser(user);
		docDokusi.setNombre(oidDokusi);
		docDokusi.setProcedureID(procedureID);

		return docDokusi;
	}

}
